﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using FreshMvvm;
using FreshMVVMSFDataGrid.Model;
using PropertyChanged;
using Xamarin.Forms;

namespace FreshMVVMSFDataGrid.ViewModel
{

    [AddINotifyPropertyChangedInterface]
    public class ViewModelBase : FreshBasePageModel
    {
        
        #region Property Vehicles

        private ObservableCollection<Vehicle> _vehicles = new ObservableCollection<Vehicle>();

        public ObservableCollection<Vehicle> Vehicles
        {
            get
            {
                return _vehicles;
            }
            set
            {
                _vehicles = value;
            }
        }

        #endregion

        public Command CloseModalCommand
        {
            get
            {
                return new Command(async () => { await CoreMethods.PopModalNavigationService(); });
            }
        }

        public override void Init(object initData)
        {
            base.Init(initData);
            Vehicles.Add(new Vehicle
            {
                Type = "Motorcycle",
                Manufacturer = "Honda",
                Model = "1000RR",
                Colour = "Red",
                NumberOfWheels = 2
            });
            Vehicles.Add(new Vehicle
            {
                Type = "Motorcycle",
                Manufacturer = "Honda",
                Model = "1000RR",
                Colour = "Red",
                NumberOfWheels = 2
            });
            Vehicles.Add(new Vehicle
            {
                Type = "Car",
                Manufacturer = "Peugeot",
                Model = "206 GTI 180",
                Colour = "Black",
                NumberOfWheels = 4
            });
            Vehicles.Add(new Vehicle
            {
                Type = "Truck",
                Manufacturer = "MAN",
                Model = "DD2000",
                Colour = "Green",
                NumberOfWheels = 8
            });
            Vehicles.Add(new Vehicle
            {
                Type = "Motorcycle",
                Manufacturer = "Yamaha",
                Model = "MBR125",
                Colour = "Yellow",
                NumberOfWheels = 2
            });
            //for (int iCount = 0; iCount < 100; iCount++)
            //{
            //    Vehicle vehicle = new Vehicle
            //    {
            //        Type = "Type " + iCount,
            //        Manufacturer = "Manufacturer " + iCount,
            //        Model = "Model " + iCount,
            //        Colour = "Colour " + iCount,
            //        NumberOfWheels = iCount,
            //    };

            //    Vehicles.Add(vehicle);

            //}

            
        }
    }
}